Package ghidra.program.util

# Class ProgramSelection

java.lang.Object
ghidra.program.util.ProgramSelection

All Implemented Interfaces:
  `AddressSetView`, `Iterable<AddressRange>`

public class ProgramSelection extends Object implements AddressSetView
Class to define a selection for a program.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ProgramSelection()`
  Construct a new empty ProgramSelection.
  `ProgramSelection(AddressFactory addressFactory)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `ProgramSelection()`
  `ProgramSelection(AddressFactory addressFactory, Address from, Address to)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `ProgramSelection(Address, Address)`
  `ProgramSelection(AddressFactory addressFactory, AddressSetView setView)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `ProgramSelection(AddressSetView)`
  `ProgramSelection(AddressFactory addressFactory, InteriorSelection sel)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `ProgramSelection(InteriorSelection)`s
  `ProgramSelection(Address from, Address to)`
  Constructor.
  `ProgramSelection(AddressSetView setView)`
  Construct a new ProgramSelection
  `ProgramSelection(InteriorSelection sel)`
  Construct a new ProgramSelection from the indicated interior selection.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `contains(Address addr)`
  Test if the address is contained within this set.
  `boolean`
  `contains(Address start, Address end)`
  Test if the given address range is contained in this set.
  `boolean`
  `contains(AddressSetView rangeSet)`
  Test if the given address set is a subset of this set.
  `boolean`
  `equals(Object obj)`
  `Address`
  `findFirstAddressInCommon(AddressSetView set)`
  Finds the first address in this collection that is also in the given addressSet.
  `AddressIterator`
  `getAddresses(boolean forward)`
  Returns an iterator over all addresses in this set.
  `AddressIterator`
  `getAddresses(Address start, boolean forward)`
  Returns an iterator over the addresses in this address set starting at the start address
  `AddressRangeIterator`
  `getAddressRanges()`
  `AddressRangeIterator`
  `getAddressRanges(boolean atStart)`
  Returns an iterator over the ranges in the specified order
  `AddressRangeIterator`
  `getAddressRanges(Address start, boolean forward)`
  Returns an iterator of address ranges starting with the range that contains the given address.
  `AddressRange`
  `getFirstRange()`
  Returns the first range in this set or null if the set is empty
  `InteriorSelection`
  `getInteriorSelection()`
  Get the interior selection.
  `AddressRange`
  `getLastRange()`
  Returns the last range in this set or null if the set is empty
  `Address`
  `getMaxAddress()`
  Get the maximum address for this address set.
  `Address`
  `getMinAddress()`
  Get the minimum address for this address set.
  `long`
  `getNumAddresses()`
  `int`
  `getNumAddressRanges()`
  `AddressRange`
  `getRangeContaining(Address address)`
  Returns the range that contains the given address
  `int`
  `hashCode()`
  `boolean`
  `hasSameAddresses(AddressSetView asv)`
  Returns true if and only if this set and the given address set contains exactly the same addresses.
  `AddressSet`
  `intersect(AddressSetView view)`
  Computes the intersection of this address set with the given address set.
  `AddressSet`
  `intersectRange(Address start, Address end)`
  Computes the intersection of this address set with the given address range.
  `boolean`
  `intersects(Address start, Address end)`
  Determine if the start and end range intersects with the specified address set.
  `boolean`
  `intersects(AddressSetView addrSet)`
  Determine if this address set intersects with the specified address set.
  `boolean`
  `isEmpty()`
  `Iterator<AddressRange>`
  `iterator()`
  Returns an iterator over the address ranges in this address set.
  `Iterator<AddressRange>`
  `iterator(boolean forward)`
  Returns an iterator over the ranges in the specified order
  `Iterator<AddressRange>`
  `iterator(Address start, boolean forward)`
  Returns an iterator of address ranges starting with the range that contains the given address.
  `AddressSet`
  `subtract(AddressSetView view)`
  Computes the difference of this address set with the given address set (this - set).
  `String`
  `toString()`
  `AddressSet`
  `union(AddressSetView view)`
  Computes the union of this address set with the given address set.
  `AddressSet`
  `xor(AddressSetView view)`
  Computes the exclusive-or of this address set with the given set.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.program.model.address.AddressSetView

  `getAddressCountBefore, spliterator, spliterator, spliterator, stream, stream, stream`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

- ## Constructor Details

  - ### ProgramSelection

    public ProgramSelection()
    Construct a new empty ProgramSelection.

  - ### ProgramSelection

    public ProgramSelection(Address from, Address to)
    Constructor.
    Parameters:
      `from` - the start of the selection
      `to` - the end of the selection

  - ### ProgramSelection

    public ProgramSelection(AddressSetView setView)
    Construct a new ProgramSelection
    Parameters:
      `setView` - address set for the selection

  - ### ProgramSelection

    public ProgramSelection(InteriorSelection sel)
    Construct a new ProgramSelection from the indicated interior selection.
    Parameters:
      `sel` - the interior selection

  - ### ProgramSelection

    @Deprecated(since="11.2", forRemoval=true) public ProgramSelection(AddressFactory addressFactory)
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `ProgramSelection()`
    Construct a new empty ProgramSelection.
    Parameters:
      `addressFactory` - NOT USED

  - ### ProgramSelection

    @Deprecated(since="11.2", forRemoval=true) public ProgramSelection(AddressFactory addressFactory, Address from, Address to)
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `ProgramSelection(Address, Address)`
    Constructor.
    Parameters:
      `addressFactory` - NOT USED
      `from` - the start of the selection
      `to` - the end of the selection

  - ### ProgramSelection

    @Deprecated(since="11.2", forRemoval=true) public ProgramSelection(AddressFactory addressFactory, AddressSetView setView)
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `ProgramSelection(AddressSetView)`
    Construct a new ProgramSelection
    Parameters:
      `addressFactory` - NOT USED
      `setView` - address set for the selection

  - ### ProgramSelection

    @Deprecated(since="11.2", forRemoval=true) public ProgramSelection(AddressFactory addressFactory, InteriorSelection sel)
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `ProgramSelection(InteriorSelection)`s
    Construct a new ProgramSelection from the indicated interior selection.
    Parameters:
      `addressFactory` - NOT USED
      `sel` - the interior selection

- ## Method Details

  - ### getInteriorSelection

    public InteriorSelection getInteriorSelection()
    Get the interior selection.
    Returns:
      null if there is no interior selection

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object obj)
    Overrides:
      `equals` in class `Object`

  - ### contains

    public boolean contains(Address addr)
    Description copied from interface: `AddressSetView`
    Test if the address is contained within this set.
    Specified by:
      `contains` in interface `AddressSetView`
    Parameters:
      `addr` - address to test.
    Returns:
      true if addr exists in the set, false otherwise.

  - ### contains

    public boolean contains(Address start, Address end)
    Description copied from interface: `AddressSetView`
    Test if the given address range is contained in this set.

    The specified start and end addresses must form a valid range within a single `AddressSpace`.

    Specified by:
      `contains` in interface `AddressSetView`
    Parameters:
      `start` - the first address in the range.
      `end` - the last address in the range.
    Returns:
      true if entire range is contained within the set, false otherwise.

  - ### contains

    public boolean contains(AddressSetView rangeSet)
    Description copied from interface: `AddressSetView`
    Test if the given address set is a subset of this set.
    Specified by:
      `contains` in interface `AddressSetView`
    Parameters:
      `rangeSet` - the set to test.
    Returns:
      true if the entire set is contained within this set, false otherwise.

  - ### intersects

    public boolean intersects(AddressSetView addrSet)
    Description copied from interface: `AddressSetView`
    Determine if this address set intersects with the specified address set.
    Specified by:
      `intersects` in interface `AddressSetView`
    Parameters:
      `addrSet` - address set to check intersection with.
    Returns:
      true if this set intersects the specified addrSet else false

  - ### intersect

    public AddressSet intersect(AddressSetView view)
    Description copied from interface: `AddressSetView`
    Computes the intersection of this address set with the given address set.

    This method does not modify this address set.

    Specified by:
      `intersect` in interface `AddressSetView`
    Parameters:
      `view` - the address set to intersect with.
    Returns:
      AddressSet a new address set that contains all addresses that are contained in both this set and the given set.

  - ### intersectRange

    public AddressSet intersectRange(Address start, Address end)
    Description copied from interface: `AddressSetView`
    Computes the intersection of this address set with the given address range.

    This method does not modify this address set. The specified start and end addresses must form a valid range within a single `AddressSpace`.

    Specified by:
      `intersectRange` in interface `AddressSetView`
    Parameters:
      `start` - start of range
      `end` - end of range
    Returns:
      AddressSet a new address set that contains all addresses that are contained in both this set and the given range.

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `AddressSetView`
    Returns:
      true if this set is empty.

  - ### getMinAddress

    public Address getMinAddress()
    Description copied from interface: `AddressSetView`
    Get the minimum address for this address set.

    NOTE: An `AddressRange` should generally not be formed using this address and `AddressSetView.getMaxAddress()` since it may span multiple `AddressSpace`s.

    Specified by:
      `getMinAddress` in interface `AddressSetView`
    Returns:
      the minimum address for this set. Returns null if the set is empty.

  - ### getMaxAddress

    public Address getMaxAddress()
    Description copied from interface: `AddressSetView`
    Get the maximum address for this address set.

    NOTE: An `AddressRange` should generally not be formed using this address and `AddressSetView.getMaxAddress()` since it may span multiple `AddressSpace`s.

    Specified by:
      `getMaxAddress` in interface `AddressSetView`
    Returns:
      the maximum address for this set. Returns null if the set is empty.

  - ### getNumAddressRanges

    public int getNumAddressRanges()
    Specified by:
      `getNumAddressRanges` in interface `AddressSetView`
    Returns:
      the number of address ranges in this set.

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges(boolean atStart)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the ranges in the specified order
    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Parameters:
      `atStart` - the ranges are returned from lowest to highest, otherwise from highest to lowest
    Returns:
      an iterator over all the addresse ranges in the set.

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges()
    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Returns:
      an iterator over the address ranges in this address set.

  - ### iterator

    public Iterator<AddressRange> iterator()
    Description copied from interface: `AddressSetView`
    Returns an iterator over the address ranges in this address set.
    Specified by:
      `iterator` in interface `AddressSetView`
    Specified by:
      `iterator` in interface `Iterable<AddressRange>`

  - ### getNumAddresses

    public long getNumAddresses()
    Specified by:
      `getNumAddresses` in interface `AddressSetView`
    Returns:
      the number of addresses in this set.

  - ### getAddresses

    public AddressIterator getAddresses(boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over all addresses in this set.
    Specified by:
      `getAddresses` in interface `AddressSetView`
    Parameters:
      `forward` - if true the address are return in increasing order, otherwise in decreasing order.
    Returns:
      an iterator over all addresses in this set.

  - ### getAddresses

    public AddressIterator getAddresses(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the addresses in this address set starting at the start address
    Specified by:
      `getAddresses` in interface `AddressSetView`
    Parameters:
      `start` - address to start iterating at in the address set
      `forward` - if true address are return from lowest to highest, else from highest to lowest
    Returns:
      an iterator over the addresses in this address set starting at the start address

  - ### hasSameAddresses

    public boolean hasSameAddresses(AddressSetView asv)
    Returns true if and only if this set and the given address set contains exactly the same addresses.
    Specified by:
      `hasSameAddresses` in interface `AddressSetView`
    Parameters:
      `asv` - the address set to compare with this one.
    Returns:
      true if the specified set has the same addresses.

  - ### intersects

    public boolean intersects(Address start, Address end)
    Description copied from interface: `AddressSetView`
    Determine if the start and end range intersects with the specified address set.

    The specified start and end addresses must form a valid range within a single `AddressSpace`.

    Specified by:
      `intersects` in interface `AddressSetView`
    Parameters:
      `start` - start of range
      `end` - end of range
    Returns:
      true if the given range intersects this address set.

  - ### union

    public AddressSet union(AddressSetView view)
    Description copied from interface: `AddressSetView`
    Computes the union of this address set with the given address set.

    This method does not change this address set.

    Specified by:
      `union` in interface `AddressSetView`
    Parameters:
      `view` - The address set to be unioned with this address set.
    Returns:
      AddressSet A new address set which contains all the addresses from both this set and the given set.

  - ### xor

    public AddressSet xor(AddressSetView view)
    Description copied from interface: `AddressSetView`
    Computes the exclusive-or of this address set with the given set.

    This method does not modify this address set.

    Specified by:
      `xor` in interface `AddressSetView`
    Parameters:
      `view` - address set to exclusive-or with.
    Returns:
      AddressSet a new address set containing all addresses that are in either this set or the given set, but not in both sets

  - ### subtract

    public AddressSet subtract(AddressSetView view)
    Description copied from interface: `AddressSetView`
    Computes the difference of this address set with the given address set (this - set).

    Note that this is not the same as (set - this). This method does not change this address set.

    Specified by:
      `subtract` in interface `AddressSetView`
    Parameters:
      `view` - the set to subtract from this set.
    Returns:
      AddressSet a new address set which contains all the addresses that are in this set, but not in the given set.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator of address ranges starting with the range that contains the given address.

    If there is no range containing the start address, then the first range will be the next range greater than the start address if going forward, otherwise the range less than the start address

    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Parameters:
      `start` - the address the first range should contain.
      `forward` - true iterators forward, false backwards
    Returns:
      the AddressRange iterator

  - ### getFirstRange

    public AddressRange getFirstRange()
    Description copied from interface: `AddressSetView`
    Returns the first range in this set or null if the set is empty
    Specified by:
      `getFirstRange` in interface `AddressSetView`
    Returns:
      the first range in this set or null if the set is empty

  - ### getLastRange

    public AddressRange getLastRange()
    Description copied from interface: `AddressSetView`
    Returns the last range in this set or null if the set is empty
    Specified by:
      `getLastRange` in interface `AddressSetView`
    Returns:
      the last range in this set or null if the set is empty

  - ### getRangeContaining

    public AddressRange getRangeContaining(Address address)
    Description copied from interface: `AddressSetView`
    Returns the range that contains the given address
    Specified by:
      `getRangeContaining` in interface `AddressSetView`
    Parameters:
      `address` - the address for which to find a range.
    Returns:
      the range that contains the given address.

  - ### iterator

    public Iterator<AddressRange> iterator(boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the ranges in the specified order
    Specified by:
      `iterator` in interface `AddressSetView`
    Parameters:
      `forward` - the ranges are returned from lowest to highest, otherwise from highest to lowest
    Returns:
      an iterator over all the address ranges in the set.

  - ### iterator

    public Iterator<AddressRange> iterator(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator of address ranges starting with the range that contains the given address.

    If there is no range containing the start address, then the first range will be the next range greater than the start address if going forward, otherwise the range less than the start address

    Specified by:
      `iterator` in interface `AddressSetView`
    Parameters:
      `start` - the address that the first range should contain.
      `forward` - true iterators forward, false backwards
    Returns:
      the AddressRange iterator

  - ### findFirstAddressInCommon

    public Address findFirstAddressInCommon(AddressSetView set)
    Description copied from interface: `AddressSetView`
    Finds the first address in this collection that is also in the given addressSet.
    Specified by:
      `findFirstAddressInCommon` in interface `AddressSetView`
    Parameters:
      `set` - the addressSet to search for the first (lowest) common address.
    Returns:
      the first address that is contained in this set and the given set.